<ng-container *ngIf="{
        plateau: plateau$ | async,
        screenSize: screenSize$ | async,
        requiredMatchCount: requiredMatchCount$ | async,
        matchStatus: matchStatus$ | async  } as vm">
  <app-page-form >
    <ng-container ngProjectAs="[page-form-content]">
      <h1>
        {{ 'fmi.match.seo.title' | translate }}
      </h1>

      <p>
        {{ 'fmi.match.seo.description' | translate }}
      </p>

      <form [formGroup]="formGroup"
            #form="ngForm" (ngSubmit)="formGroup.valid && save()">
        <form formArrayName="matchs">
          <ng-container *ngFor="let matchFormGroup of matchFormGroups; let index = index">
            <mat-card>
              <mat-card-content>
                <form [formGroup]="matchFormGroup" class="match">
                  <mat-form-field class="date">
                    <mat-label>
                      {{ 'fmi.match.form.date' | translate }}
                    </mat-label>
                    <mat-datetimepicker-toggle [for]="datetimePicker" matSuffix></mat-datetimepicker-toggle>
                    <mat-datetimepicker #datetimePicker type="time" openOnFocus="true"
                                        timeInterval="5"></mat-datetimepicker>
                    <input matInput formControlName="date" [matDatetimepicker]="datetimePicker" required
                           autocomplete="false">
                    <mat-error *ngIf="matchFormGroup.controls.date.errors?.required">
                      {{ 'admin.common.validation.required' | translate }}
                    </mat-error>
                  </mat-form-field>

                  <figure class="logo1"
                          *ngIf="getTeamBySlug(vm.plateau?.teams, matchFormGroup.controls.team1.value) as team">
                    <img *ngIf="'common.team.defaultPicture.url' | translate"
                         class="lazy-load"
                         [lazyLoad]="team.logoUrl || ('common.team.defaultPicture.url' | translate)"
                         [errorImage]="'common.team.defaultPicture.url' | translate"
                         [alt]="team.name"/>
                  </figure>

                  <mat-form-field class="team1">
                    <mat-label>
                      {{ 'fmi.match.form.team1' | translate }}
                    </mat-label>
                    <app-reset-button-icon matPrefix
                                           [display]="!!matchFormGroup.getRawValue().team1"
                                           (resetClick)="matchFormGroup.controls.team1.patchValue(undefined)">
                    </app-reset-button-icon>
                    <mat-select formControlName="team1">
                      <ng-container *ngFor="let team of vm.plateau?.teams; trackBy: trackBySlug">
                        <mat-option *ngIf="team.slug !== matchFormGroup.controls.team2.value"
                                    class="team"
                                    [value]="team.slug">
                          <figure>
                            <img *ngIf="'common.team.defaultPicture.url' | translate"
                                 class="lazy-load"
                                 [lazyLoad]="team.logoUrl"
                                 [errorImage]="'common.team.defaultPicture.url' | translate"
                                 [alt]="team.name"/>
                            <figcaption>
                              {{ team | teamName:vm.screenSize }}
                              {{ team.index }}
                            </figcaption>
                          </figure>
                        </mat-option>
                      </ng-container>
                    </mat-select>
                    <mat-error *ngIf="matchFormGroup.controls.team1.errors?.required">
                      {{ 'admin.common.validation.required' | translate }}
                    </mat-error>
                  </mat-form-field>

                  <mat-form-field class="team2">
                    <mat-label>
                      {{ 'fmi.match.form.team2' | translate }}
                    </mat-label>
                    <app-reset-button-icon matPrefix
                                           [display]="!!matchFormGroup.getRawValue().team2"
                                           (resetClick)="matchFormGroup.controls.team2.patchValue(undefined)">
                    </app-reset-button-icon>
                    <mat-select formControlName="team2">
                      <ng-container *ngFor="let team of vm.plateau?.teams; trackBy: trackBySlug">
                        <mat-option *ngIf="team.slug !== matchFormGroup.controls.team1.value"
                                    class="team"
                                    [value]="team.slug">
                          <figure>
                            <img *ngIf="'common.team.defaultPicture.url' | translate"
                                 class="lazy-load"
                                 [lazyLoad]="team.logoUrl"
                                 [errorImage]="'common.team.defaultPicture.url' | translate"
                                 [alt]="team.name"/>
                            <figcaption>
                              {{ team | teamName:vm.screenSize }}
                              {{ team.index }}
                            </figcaption>
                          </figure>
                        </mat-option>
                      </ng-container>
                    </mat-select>
                    <mat-error *ngIf="matchFormGroup.controls.team2.errors?.required">
                      {{ 'admin.common.validation.required' | translate }}
                    </mat-error>
                  </mat-form-field>

                  <figure class="logo2"
                          *ngIf="getTeamBySlug(vm.plateau?.teams, matchFormGroup.controls.team2.value) as team">
                    <img *ngIf="'common.team.defaultPicture.url' | translate"
                         class="lazy-load"
                         [lazyLoad]="team.logoUrl || ('common.team.defaultPicture.url' | translate)"
                         [errorImage]="'common.team.defaultPicture.url' | translate"
                         [alt]="team.name"/>
                  </figure>

                  <button type="button" mat-icon-button class="delete"
                          [attr.aria-label]="'fmi.match.action.match.delete' | translate"
                          (click)="deleteMatchGroup(index)"
                          angulartics2On="click"
                          [angularticsValue]="vm.plateau?.slug"
                          angularticsLabel="match"
                          angularticsAction="delete"
                          angularticsCategory="fmi-match">
                    <mat-icon>
                      delete
                    </mat-icon>
                  </button>
                </form>
              </mat-card-content>
            </mat-card>
          </ng-container>
        </form>

        <article *ngIf="vm.plateau">
          <mat-icon *ngIf="vm.matchStatus"
                    [ngClass]="vm.matchStatus">
            <ng-container [ngSwitch]="vm.matchStatus">
              <ng-container *ngSwitchCase="FmiMatchStatus.COMPLETE">check_circle</ng-container>
              <ng-container *ngSwitchCase="FmiMatchStatus.PARTIAL">warning</ng-container>
              <ng-container *ngSwitchCase="FmiMatchStatus.EMPTY">error</ng-container>
            </ng-container>
          </mat-icon>
          <p>
            {{ 'admin.fmi.list.field.matchStatus.value' | translate:{ status: 'admin.fmi.matchStatus.' + vm.matchStatus | translate, matchCount: getValidMatchFormGroupCount(), requiredMatchCount: vm.requiredMatchCount, teamCount: vm.plateau.teams?.length } }}
          </p>
        </article>

        <button type="button" mat-stroked-button color="primary"
                (click)="addMatchGroup(vm.plateau)"
                angulartics2On="click"
                [angularticsValue]="vm.plateau?.slug"
                angularticsLabel="match"
                angularticsAction="add"
                angularticsCategory="fmi-match">
          <mat-icon>
            add
          </mat-icon>
          {{ 'fmi.match.action.match.add'  | translate }}
        </button>
      </form>
    </ng-container>
    <ng-container ngProjectAs="[page-form-footer]">
      <a mat-stroked-button color="accent"
         [routerLink]="previousRouteCommands.commands"
         [queryParams]="previousRouteCommands.queryParams"
         angulartics2On="click"
         angularticsAction="cancel"
         angularticsCategory="fmi-match">
        <mat-icon>
          cancel
        </mat-icon>
        {{ 'fmi.match.action.cancel' | translate }}
      </a>
      <app-async-button [loading]="loading.save">
        <button mat-flat-button color="primary"
                [disabled]="!formGroup.value.slug"
                (click)="form.onSubmit($event)"
                angulartics2On="click"
                angularticsLabel="matchs"
                angularticsAction="save"
                angularticsCategory="fmi-match">
          <mat-icon>
            save
          </mat-icon>
          {{ 'fmi.match.action.save' | translate }}
        </button>
      </app-async-button>
    </ng-container>
  </app-page-form>
</ng-container>
